from ...register import register
from ..simplified_tetris_binary_env import SimplifiedTetrisBinaryEnv
from .simplified_tetris_shaping_reward import SimplifiedTetrisShapingReward


class SimplifiedTetrisBinaryShapedEnv(
    SimplifiedTetrisShapingReward, SimplifiedTetrisBinaryEnv
):
    """
    A class representing a Tetris environment, where the reward function is a
    potential-based shaping reward and the observation space is the grid's binary repr plus the current piece's id.

    :param grid_dims: the grid's dimensions.
    :param piece_size: the size of the pieces in use.
    :param seed: the rng seed.
    """

    def __init__(self, **kwargs):
        super().__init__()
        SimplifiedTetrisBinaryEnv.__init__(self, **kwargs)


register(
    incomplete_id="simplifiedtetris-binary-shaped",
    entry_point="gym_simplifiedtetris.envs:SimplifiedTetrisBinaryShapedEnv",
)
