from typing import Dict, List, Tuple, Union

PieceCoord = List[Tuple[int, int]]
Rotation = int
PieceCoords = Dict[Rotation, PieceCoord]
PieceInfo = Dict[str, Union[PieceCoords, str]]
PieceID = int
PiecesInfo = Dict[PieceID, PieceInfo]
PieceSize = int

PIECES_DICT: Dict[PieceSize, PiecesInfo] = {
    1: {0: {"coords": {0: [(0, 0)]}, "name": "O"}},
    2: {0: {"coords": {0: [(0, 0), (0, -1)], 90: [(0, 0), (1, 0)]}, "name": "I"}},
    3: {
        0: {
            "coords": {
                0: [(0, 0), (0, -1), (0, -2)],
                90: [(0, 0), (1, 0), (2, 0)],
                180: [(0, 0), (0, 1), (0, 2)],
                270: [(0, 0), (-1, 0), (-2, 0)],
            },
            "name": "I",
        },
        1: {
            "coords": {
                0: [(0, 0), (1, 0), (0, -1)],
                90: [(0, 0), (0, 1), (1, 0)],
                180: [(0, 0), (-1, 0), (0, 1)],
                270: [(0, 0), (0, -1), (-1, 0)],
            },
            "name": "L",
        },
    },
    4: {
        0: {
            "coords": {
                0: [(0, 0), (0, -1), (0, -2), (0, -3)],
                90: [(0, 0), (1, 0), (2, 0), (3, 0)],
                180: [(0, 0), (0, 1), (0, 2), (0, 3)],
                270: [(0, 0), (-1, 0), (-2, 0), (-3, 0)],
            },
            "name": "I",
        },
        1: {
            "coords": {
                0: [(0, 0), (1, 0), (0, -1), (0, -2)],
                90: [(0, 0), (0, 1), (1, 0), (2, 0)],
                180: [(0, 0), (-1, 0), (0, 1), (0, 2)],
                270: [(0, 0), (0, -1), (-1, 0), (-2, 0)],
            },
            "name": "L",
        },
        2: {
            "coords": {
                0: [(0, 0), (0, -1), (-1, 0), (-1, -1)],
                90: [(0, 0), (1, 0), (0, -1), (1, -1)],
                180: [(0, 0), (0, 1), (1, 0), (1, 1)],
                270: [(0, 0), (-1, 0), (0, 1), (-1, 1)],
            },
            "name": "O",
        },
        3: {
            "coords": {
                0: [(0, 0), (-1, 0), (1, 0), (0, 1)],
                90: [(0, 0), (0, -1), (0, 1), (-1, 0)],
                180: [(0, 0), (1, 0), (-1, 0), (0, -1)],
                270: [(0, 0), (0, 1), (0, -1), (1, 0)],
            },
            "name": "T",
        },
        4: {
            "coords": {
                0: [(0, 0), (-1, 0), (0, -1), (0, -2)],
                90: [(0, 0), (0, -1), (1, 0), (2, 0)],
                180: [(0, 0), (1, 0), (0, 1), (0, 2)],
                270: [(0, 0), (0, 1), (-1, 0), (-2, 0)],
            },
            "name": "J",
        },
        5: {
            "coords": {
                0: [(0, 0), (-1, 0), (0, -1), (1, -1)],
                90: [(0, 0), (0, -1), (1, 0), (1, 1)],
                180: [(0, 0), (1, 0), (0, 1), (-1, 1)],
                270: [(0, 0), (0, 1), (-1, 0), (-1, -1)],
            },
            "name": "S",
        },
        6: {
            "coords": {
                0: [(0, 0), (-1, -1), (0, -1), (1, 0)],
                90: [(0, 0), (1, -1), (1, 0), (0, 1)],
                180: [(0, 0), (1, 1), (0, 1), (-1, 0)],
                270: [(0, 0), (-1, 1), (-1, 0), (0, -1)],
            },
            "name": "Z",
        },
    },
}
